package hilfsklassen;

/**löst ein Lineares Gleichungssystem 2.,3. und 4. Ordnung mit Cramerscher Regel*/
public class Cramer
{
    public static double det;
//z.Zt. nur bis zu 4 Zwangsbedingungen!!!
    public static boolean loese(double[] x,double[][] A, double[] b)
    {
        if(b.length==2)
            return loese2(x,A,b);
        else if(b.length==3)
            return loese3(x,A,b);
        else if(b.length==4)
            return loese4(x,A,b);
        else
            return false;        
    }


    public static boolean loese2(double[] x,double[][] A, double[] b)
    {
        det  = A[0][0]*A[1][1] - A[1][0]*A[0][1];
        if(det==0.0)
            return false;

        x[0] = (b[0]*A[1][1] - b[1]*A[0][1])/det;
        x[1] = (A[0][0]*b[1] - A[1][0]*b[0])/det;
        return true;
    }
    
    public static boolean loese3(double[] x,double[][] A, double[] b)
    {
        det  =  A[0][0]*(A[1][1]*A[2][2]-A[2][1]*A[1][2])
               -A[0][1]*(A[1][0]*A[2][2]-A[2][0]*A[1][2])
               +A[0][2]*(A[1][0]*A[2][1]-A[2][0]*A[1][1]);
        if(det==0.0)
            return false;

        x[0] = (
                     b[0]*(A[1][1]*A[2][2]-A[2][1]*A[1][2])
                 -A[0][1]*(   b[1]*A[2][2]-   b[2]*A[1][2])
                 +A[0][2]*(   b[1]*A[2][1]-   b[2]*A[1][1])
               )/det;
               
        x[1] = (
                  A[0][0]*(   b[1]*A[2][2]-   b[2]*A[1][2])
                 -   b[0]*(A[1][0]*A[2][2]-A[2][0]*A[1][2])
                 +A[0][2]*(A[1][0]*   b[2]-A[2][0]*   b[1])
               )/det;
               
        x[2] = (
                  A[0][0]*(A[1][1]*   b[2]-A[2][1]*   b[1])
                 -A[0][1]*(A[1][0]*   b[2]-A[2][0]*   b[1])
                 +   b[0]*(A[1][0]*A[2][1]-A[2][0]*A[1][1])
               )/det;    
        return true;                  
    }
    
    public static boolean loese4(double[] x,double[][] A, double[] b)
    {
        det =  A[0][0]*
               (
                    A[1][1]*(A[2][2]*A[3][3]-A[3][2]*A[2][3])
                   -A[1][2]*(A[2][1]*A[3][3]-A[3][1]*A[2][3])
                   +A[1][3]*(A[2][1]*A[3][2]-A[3][1]*A[2][2])           
               )
              -A[0][1]*
               (
                    A[1][0]*(A[2][2]*A[3][3]-A[3][2]*A[2][3])
                   -A[1][2]*(A[2][0]*A[3][3]-A[3][0]*A[2][3])
                   +A[1][3]*(A[2][0]*A[3][2]-A[3][0]*A[2][2])           
               )
              +A[0][2]*
               (
                    A[1][0]*(A[2][1]*A[3][3]-A[3][1]*A[2][3])
                   -A[1][1]*(A[2][0]*A[3][3]-A[3][0]*A[2][3])
                   +A[1][3]*(A[2][0]*A[3][1]-A[3][0]*A[2][1])           
               )
              -A[0][3]*
               (
                    A[1][0]*(A[2][1]*A[3][2]-A[3][1]*A[2][2])
                   -A[1][1]*(A[2][0]*A[3][2]-A[3][0]*A[2][2])
                   +A[1][2]*(A[2][0]*A[3][1]-A[3][0]*A[2][1])           
               );      
        if(det==0.0)
            return false;

        x[0] = (
                    b[0]*
                 (
                    A[1][1]*(A[2][2]*A[3][3]-A[3][2]*A[2][3])
                   -A[1][2]*(A[2][1]*A[3][3]-A[3][1]*A[2][3])
                   +A[1][3]*(A[2][1]*A[3][2]-A[3][1]*A[2][2])           
                 )
                -A[0][1]*
                 (
                       b[1]*(A[2][2]*A[3][3]-A[3][2]*A[2][3])
                   -A[1][2]*(   b[2]*A[3][3]-   b[3]*A[2][3])
                   +A[1][3]*(   b[2]*A[3][2]-   b[3]*A[2][2])           
                 )
                +A[0][2]*
                 (
                       b[1]*(A[2][1]*A[3][3]-A[3][1]*A[2][3])
                   -A[1][1]*(   b[2]*A[3][3]-   b[3]*A[2][3])
                   +A[1][3]*(   b[2]*A[3][1]-   b[3]*A[2][1])           
                 )
                -A[0][3]*
                 (
                       b[1]*(A[2][1]*A[3][2]-A[3][1]*A[2][2])
                   -A[1][1]*(   b[2]*A[3][2]-   b[3]*A[2][2])
                   +A[1][2]*(   b[2]*A[3][1]-   b[3]*A[2][1])           
                 )      
               )/det;        

        x[1] = (
                 A[0][0]*
                 (
                       b[1]*(A[2][2]*A[3][3]-A[3][2]*A[2][3])
                   -A[1][2]*(   b[2]*A[3][3]-   b[3]*A[2][3])
                   +A[1][3]*(   b[2]*A[3][2]-   b[3]*A[2][2])           
                 )
                -   b[0]*
                 (
                    A[1][0]*(A[2][2]*A[3][3]-A[3][2]*A[2][3])
                   -A[1][2]*(A[2][0]*A[3][3]-A[3][0]*A[2][3])
                   +A[1][3]*(A[2][0]*A[3][2]-A[3][0]*A[2][2])           
                 )
                +A[0][2]*
                 (
                    A[1][0]*(   b[2]*A[3][3]-   b[3]*A[2][3])
                   -   b[1]*(A[2][0]*A[3][3]-A[3][0]*A[2][3])
                   +A[1][3]*(A[2][0]*   b[3]-A[3][0]*   b[2])           
                 )
                -A[0][3]*
                 (
                    A[1][0]*(   b[2]*A[3][2]-   b[3]*A[2][2])
                   -   b[1]*(A[2][0]*A[3][2]-A[3][0]*A[2][2])
                   +A[1][2]*(A[2][0]*   b[3]-A[3][0]*   b[2])           
                 )      
               )/det;        

        x[2] = (
                 A[0][0]*
                 (
                    A[1][1]*(   b[2]*A[3][3]-   b[3]*A[2][3])
                   -   b[1]*(A[2][1]*A[3][3]-A[3][1]*A[2][3])
                   +A[1][3]*(A[2][1]*   b[3]-A[3][1]*   b[2])           
                 )
                -A[0][1]*
                 (
                    A[1][0]*(   b[2]*A[3][3]-   b[3]*A[2][3])
                   -   b[1]*(A[2][0]*A[3][3]-A[3][0]*A[2][3])
                   +A[1][3]*(A[2][0]*   b[3]-A[3][0]*   b[2])           
                 )
                +   b[0]*
                 (
                    A[1][0]*(A[2][1]*A[3][3]-A[3][1]*A[2][3])
                   -A[1][1]*(A[2][0]*A[3][3]-A[3][0]*A[2][3])
                   +A[1][3]*(A[2][0]*A[3][1]-A[3][0]*A[2][1])           
                 )
                -A[0][3]*
                 (
                    A[1][0]*(A[2][1]*   b[3]-A[3][1]*   b[2])
                   -A[1][1]*(A[2][0]*   b[3]-A[3][0]*   b[2])
                   +   b[1]*(A[2][0]*A[3][1]-A[3][0]*A[2][1])           
                 )      
               )/det;        

        x[3] = (
                 A[0][0]*
                 (
                    A[1][1]*(A[2][2]*   b[3]-A[3][2]*   b[2])
                   -A[1][2]*(A[2][1]*   b[3]-A[3][1]*   b[2])
                   +   b[1]*(A[2][1]*A[3][2]-A[3][1]*A[2][2])           
                 )
                -A[0][1]*
                 (
                    A[1][0]*(A[2][2]*   b[3]-A[3][2]*   b[2])
                   -A[1][2]*(A[2][0]*   b[3]-A[3][0]*   b[2])
                   +   b[1]*(A[2][0]*A[3][2]-A[3][0]*A[2][2])           
                 )
                +A[0][2]*
                 (
                    A[1][0]*(A[2][1]*   b[3]-A[3][1]*   b[2])
                   -A[1][1]*(A[2][0]*   b[3]-A[3][0]*   b[2])
                   +   b[1]*(A[2][0]*A[3][1]-A[3][0]*A[2][1])           
                 )
                -   b[0]*
                 (
                    A[1][0]*(A[2][1]*A[3][2]-A[3][1]*A[2][2])
                   -A[1][1]*(A[2][0]*A[3][2]-A[3][0]*A[2][2])
                   +A[1][2]*(A[2][0]*A[3][1]-A[3][0]*A[2][1])           
                 )      
               )/det;        
               
           return true;    
    }
}
//kommentar
