package konstanten;


/**
 * Spezielle Klasse, die die Modellparameter zusammenfasst, um sie sowohl in
 * Animation und im Modell verfügbar zu haben.
 * KÖRPER1 (Rad)
 * m1=0,094kg
 * r = 0,035m Radradius
 * J1=0,0000576 kgm2
 * 
 * KÖRPER2 (Rumpf)
 * m2 = 0,364kg
 * d = 0,06m     Abstand Achse zu Rumpfschwerpunkt
 * b = 0,057m    Rumpf-Breite
 * h = 0,14m     Rumpf-Höhe
 * J2=0,000693 kgm2
 *
 * Konvention: 1Pixel == 5mm
 *
*/
public class Konst
{
    //Fenster:
    public static int BREITE = 600;
    public static int HOEHE  = 400;
    public static int XOFF = BREITE/2;       //Koordinatenursprung-Lage in Pixeln, x
    public static int YOFF = HOEHE/2;       //Koordinatenursprung-Lage in Pixeln, y
    
    public static double dBREITE = (double)BREITE;
    public static double dHOEHE  = (double)HOEHE;

    //Animation:
    public static double skalierung = 1000.0; //1m == 1000Pixel
    
    //Rad:
    public static double m1=0.094;
    public static double r=0.035;
    public static double J1=0.0000576;
    
    //Rumpf:
    public static double m2=0.364;
    public static double d=0.06;
    public static double b=0.057;
    public static double h=0.14;
    public static double J2=0.000693;
    
}
