package simulator;


import modell.iModell;
import integrator.iIntegrator;

public class Simulator
{
    public double[][] y;
    public double[] y_alt;
    public double[] y_neu;
    public double[]   t;
    public int schritte;    

    public iModell modell;
    public iIntegrator integrator;
    
    // instance variables - replace the example below with your own
    public Simulator(iModell modell,iIntegrator integrator)
    {
        this.modell = modell;
        this.integrator = integrator;
    }
    
    public void simulieren(double[] parameter, double[] y0, double tmin, double tmax, double dt)
    {
        modell.setzeParameter(parameter);
        
        schritte = (int)((tmax-tmin)/dt);
        
        if(y==null || y.length!=y0.length || y[0].length!=schritte)
        {
            y = new double[y0.length][schritte];
        }
        if(t==null || t.length!=schritte)
        {
            t=new double[schritte];
        }
        if(y_alt==null || y_alt.length!=y0.length)
        {
            y_alt = new double[y0.length];
        }
        if(y_neu==null || y_neu.length!=y0.length)
        {
            y_neu = new double[y0.length];
        }
        
        for(int i=0;i<y0.length;i++)
        {
            y_alt[i]=y0[i];
            y[i][0]=y0[i];
        }
        t[0]=tmin;
        for(int i=1;i<schritte;i++)
        {
               t[i]=t[i-1]+dt;               
               y_neu = integrator.zeitschritt(y_alt,t[i],dt);               
               for(int k=0;k<y_neu.length;k++)
               {
                   y[k][i]  = y_neu[k];
                   y_alt[k] = y_neu[k];
               }
        }
    }
}
